/*******************************************************************************
********************************************************************************
** COPYRIGHT:    (c) 2011 Rohde & Schwarz, Munich
** MODULE:       main.cpp
** ABBREVIATION:   
** COMPILER:     Visual C++ 2005
** LANGUAGE:     C/C++
** AUTHOR:       Christian Poessinger
** ABSTRACT:     Example for validating the AMMOS-ZF data via 10G Ethernet.
                 This example requires WinPcap version 4.1.2 or later!
** PREMISES:     
** REMARKS:      This program is distributed in the hope that it will be useful,
                 but WITHOUT ANY WARRANTY!
** HISTORY:
**  2011-06-10: (poessing) Creation
** REVIEW:       
********************************************************************************/

/* INCLUDE FILES ***************************************************************/
#include <cstdio>
#include "10GSock.h"

/* EXPORT */

/* GLOBAL VARIABLES DEFINITION *************************************************/

/* GLOBAL CONSTANTS DEFINITION *************************************************/

/* GLOBAL DEFINES **************************************************************/

/* LOCAL DEFINES ***************************************************************/
#define VERSION "0.02"

#define HELP_NOTICE \
"\nUsage:\n" \
"  10GEXAMPLE [OPTIONS] <device>\n" \
"\n" \
"  <device> Number of Ethernet device to use\n" \
"\n" \
"OPTIONS:\n" \
"  -l  list all devices\n" \
"\n"

/* LOCAL TYPES DECLARATION *****************************************************/

/* LOCAL CLASSES DECLARATION ***************************************************/

/* LOCAL VARIABLES DEFINITION **************************************************/

/* LOCAL CONSTANTS DEFINITION **************************************************/

/* LOCAL FUNCTIONS DEFINITION **************************************************/

/* GLOBAL FUNCTIONS DEFINITION *************************************************/

/* FUNCTION ********************************************************************/
int main(int argc, char **argv)
/*
SPECIFICATION: main function for this example
PARAMETERS:
  int argc    : Number of command line arguments
  char **argv : Pointer to command line arguments
PRECONDITIONS: 
SIDE_EFFECTS: 
RETURN_VALUES: 
EXCEPTIONS: 
********************************************************************************/
{
    bool bCmdLineOK = true;
    unsigned int nInterface = 1;
    C10GSock *p10GSock = NULL;

    printf("10GEXAMPLE %s, Copyright (c) 2011 Rohde&Schwarz, Munich\n\n", VERSION);

    p10GSock = new C10GSock();

    p10GSock->FindAndSelectInterface();
    p10GSock->CreateSocket();
}